package betterwithmods.client.model.generators;

import betterwithmods.client.tesr.TESRWaterwheel;
import net.minecraft.util.math.MathHelper;

public class ModelWaterwheel extends ModelRadialBlades {

    public ModelWaterwheel() {
        super(8);
    }

    @Override
    protected ModelPart createBlade(int index) {
        double rotation = (Math.PI * index) / (bladeCount / 2);

        ModelPart combo = new ModelPart(this, 0, 0);

        ModelPart paddle = new ModelPart(this, 0, 0)
                .func_78787_b(16, 16)
                .func_78789_a(2.5F, -1.0F, -7.0F, 36, 2, 14)
                .setRotationCenter(0F, 0F, 0F)
                .setRotateAngle(0, 0, rotation);
        combo.func_78792_a(paddle);

        ModelPart blade = new ModelPart(this, 0, 0)
                .func_78787_b(16, 16)
                .func_78789_a(0.0F, -1.0F, -6.0F, 22, 2, 12)
                .setRotationCenter(30.0F * MathHelper.func_76134_b((float) rotation), 30.0F * MathHelper.func_76126_a((float) rotation), 0.0F)
                .setRotateAngle(0, 0, 1.96 + rotation);

        combo.func_78792_a(blade);

        combo.setTexture(TESRWaterwheel.WATERWHEEL);
        return combo;
    }
}
