package betterwithmods.common.blocks;

import betterwithmods.BetterWithMods;
import betterwithmods.api.tile.dispenser.IBehaviorCollect;
import betterwithmods.api.tile.dispenser.IBehaviorEntity;
import betterwithmods.common.tile.TileAdvancedDispenser;
import betterwithmods.library.common.block.BlockActiveFacing;
import betterwithmods.library.utils.CapabilityUtils;
import betterwithmods.library.utils.DirUtils;
import betterwithmods.library.utils.InventoryUtils;
import betterwithmods.library.utils.RedstoneUtils;
import betterwithmods.library.utils.ingredient.EntityIngredient;
import betterwithmods.module.internal.AdvancedDispenserRegistry;
import net.minecraft.block.Block;
import net.minecraft.block.BlockSourceImpl;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.dispenser.IBehaviorDispenseItem;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Random;

public class BlockAdvancedDispenser extends BlockActiveFacing {

    public BlockAdvancedDispenser() {
        super(Material.field_151576_e);
        this.func_149711_c(3.5F);
        this.setHarvestLevel("pickaxe", 0);
    }

    @Override
    public int func_149738_a(World worldIn) {
        return 1;
    }

    @Override
    public boolean func_180639_a(World world, @Nonnull BlockPos pos, IBlockState state, @Nonnull EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (!player.func_70093_af() && !world.field_72995_K) {
            TileEntity tile = world.func_175625_s(pos);
            if (tile != null && CapabilityUtils.hasInventory(tile, null)) {
                player.openGui(BetterWithMods.instance, 0, world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
            }
        }
        return true;
    }

    @Override
    public void func_189540_a(IBlockState state, World world, @Nonnull BlockPos pos, Block blockIn, BlockPos other) {
        boolean flag = RedstoneUtils.isRedstonePowered(state, world, pos);
        boolean flag1 = state.func_177229_b(ACTIVE);
        if (flag && !flag1) {
            world.func_175684_a(pos, this, this.func_149738_a(world));
            world.func_180501_a(pos, state.func_177226_a(ACTIVE, true), 5);
        } else if (!flag && flag1) {
            world.func_175684_a(pos, this, this.func_149738_a(world));
            world.func_180501_a(pos, state.func_177226_a(ACTIVE, false), 5);
        }
    }

    @Override
    public void func_180663_b(World world, @Nonnull BlockPos pos, @Nonnull IBlockState state) {
        TileEntity te = world.func_175625_s(pos);
        if (te instanceof TileAdvancedDispenser) {
            InventoryUtils.ejectInventoryContents(world, pos, ((TileAdvancedDispenser) te).inventory);
            world.func_175666_e(pos, this);
        }
        super.func_180663_b(world, pos, state);
    }

    @Override
    public boolean hasTileEntity(IBlockState state) {
        return true;
    }

    @Nullable
    @Override
    public TileEntity createTileEntity(World world, IBlockState state) {
        return new TileAdvancedDispenser();
    }

    public boolean func_149740_M(IBlockState state) {
        return true;
    }

    public int func_180641_l(IBlockState blockState, World worldIn, @Nonnull BlockPos pos) {
        TileEntity tile = worldIn.func_175625_s(pos);
        return CapabilityUtils.getInventory(tile, null).map(InventoryUtils::calculateComparatorLevel).orElse(0);
    }

    @Override
    public IBlockState getStateForPlacement(World world, BlockPos pos, EnumFacing facing, float hitX, float hitY, float hitZ, int meta, EntityLivingBase placer, EnumHand hand) {
        return super.getStateForPlacement(world, pos, facing, hitX, hitY, hitZ, meta, placer, hand).func_177226_a(DirUtils.FACING, EnumFacing.func_190914_a(pos, placer));
    }

    @Override
    public void func_180650_b(World worldIn, BlockPos pos, IBlockState state, Random rand) {
        if (!worldIn.field_72995_K) {
            dispense(worldIn, pos, state.func_177229_b(ACTIVE));
        }
    }

    public void dispense(@Nonnull World world, @Nonnull BlockPos pos, boolean active) {
        BlockSourceImpl impl = new BlockSourceImpl(world, pos);
        TileAdvancedDispenser tile = impl.func_150835_j();

        if (active) {
            int index = tile.nextIndex;
            ItemStack stack = tile.getNextStackFromInv();
            if (index == -1 || stack.func_190926_b())
                world.func_175718_b(1001, pos, 0);
            else {
                IBehaviorDispenseItem behavior = AdvancedDispenserRegistry.BLOCK_DISPENSER_REGISTRY.findValue(stack);
                behavior.func_82482_a(impl, stack);
            }
        } else {

            BlockPos check = pos.func_177972_a(impl.func_189992_e().func_177229_b(DirUtils.FACING));
            IBlockState state = world.func_180495_p(check);
            Block block = state.func_177230_c();


            if (world.func_180495_p(check).func_185887_b(world, check) < 0)
                return;

            IBehaviorEntity behaviorEntity = AdvancedDispenserRegistry.ENTITY_COLLECT_REGISTRY.findValue(world, check, null);
            Entity entity = EntityIngredient.getEntity(world, check).orElse(null);
            if (behaviorEntity != null && entity != null) {
                NonNullList<ItemStack> stacks = behaviorEntity.collect(world, check, entity, tile.getCurrentSlot());
                InventoryUtils.insert(tile.func_145831_w(), check, tile.inventory, stacks, false);
                return;
            }


            IBehaviorCollect behaviorCollect = AdvancedDispenserRegistry.BLOCK_COLLECT_REGISTRY.findValue(world, check, state);
            if (!world.func_175623_d(check) || !block.func_176200_f(world, check)) {
                NonNullList<ItemStack> stacks = behaviorCollect.collect(new BlockSourceImpl(world, check));
                InventoryUtils.insert(tile.func_145831_w(), check, tile.inventory, stacks, false);
            }

        }

    }

}
