package betterwithmods.common.blocks.mechanical;

import betterwithmods.api.BWMAPI;
import betterwithmods.common.tile.TileClutchbox;
import betterwithmods.library.utils.DirUtils;
import betterwithmods.util.WorldUtils;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import java.util.Random;

public class BlockClutchBox extends BlockGearbox {

    private static final PropertyBool REDSTONE = PropertyBool.func_177716_a("redstone");

    public BlockClutchBox(Material material, int maxPower) {
        super(material, maxPower);
        func_180632_j(func_176223_P().func_177226_a(REDSTONE, false));
    }

    @Override
    public TileEntity createTileEntity(@Nonnull World world, @Nonnull IBlockState state) {
        return new TileClutchbox(maxPower);
    }

    @Nonnull
    @Override
    public IBlockState func_176221_a(@Nonnull IBlockState state, IBlockAccess world, BlockPos pos) {
        boolean redstone = BWMAPI.IMPLEMENTATION.isRedstonePowered(world, pos);
        return super.func_176221_a(state, world, pos).func_177226_a(REDSTONE, redstone);
    }

    @Override
    public void func_180655_c(IBlockState state, World world, BlockPos pos, Random rand) {
        super.func_180655_c(state, world, pos, rand);
    }

    @Override
    public IProperty<?>[] getProperties() {
        return new IProperty[]{DirUtils.FACING, ACTIVE, REDSTONE, DirUtils.UP, DirUtils.DOWN, DirUtils.NORTH, DirUtils.SOUTH, DirUtils.WEST, DirUtils.EAST};
    }


}
