package betterwithmods.common.entity;

import betterwithmods.lib.ModLib;
import net.minecraft.block.BlockLeaves;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.monster.EntityCaveSpider;
import net.minecraft.init.Blocks;
import net.minecraft.init.MobEffects;
import net.minecraft.potion.PotionEffect;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.EnumDifficulty;
import net.minecraft.world.EnumSkyBlock;
import net.minecraft.world.World;
import net.minecraft.world.storage.loot.LootTableList;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.ArrayList;

public class EntityJungleSpider extends EntityCaveSpider {
    public static final ResourceLocation LOOT = LootTableList.func_186375_a(new ResourceLocation(ModLib.MODID, "entity/jungle_spider"));

    public EntityJungleSpider(World worldIn) {
        super(worldIn);
    }

    @Override
    public boolean func_70652_k(@Nonnull Entity entityIn) {
        if (super.func_70652_k(entityIn)) {
            if (entityIn instanceof EntityLivingBase) {
                int duration = 0;

                if (this.field_70170_p.func_175659_aa() == EnumDifficulty.NORMAL) {
                    duration = 7;
                } else if (this.field_70170_p.func_175659_aa() == EnumDifficulty.HARD) {
                    duration = 15;
                }

                if (duration > 0) {
                    ((EntityLivingBase) entityIn).func_70690_d(new PotionEffect(MobEffects.field_76438_s, duration * 20, 0));
                }
            }

            return true;
        } else {
            return false;
        }
    }

    @Nullable
    @Override
    protected ResourceLocation func_184647_J() {
        return LOOT;
    }

    @Override
    protected boolean func_70814_o() {
        BlockPos blockpos = new BlockPos(this.field_70165_t, this.func_174813_aQ().field_72338_b, this.field_70161_v);

        return this.field_70170_p.func_175642_b(EnumSkyBlock.BLOCK, blockpos) <= 7;
    }

    @Override
    public boolean func_70601_bi() {
        BlockPos pos = new BlockPos(this.field_70165_t, this.func_174813_aQ().field_72338_b, this.field_70161_v);
        BlockPos topPos = field_70170_p.func_175645_m(pos).func_177977_b();
        IBlockState topBlock = field_70170_p.func_180495_p(topPos);

        //On the ground, search up a little, just so we can also spawn in caves
        ArrayList<Integer> possible_spawns = getPossibleSpawnHeights(new BlockPos.MutableBlockPos(pos.func_177981_b(32)), 32);
        //Otherwise, if there's a leaf canopy search from there
        if (possible_spawns.isEmpty() && topBlock.func_177230_c() == Blocks.field_150362_t && topBlock.func_177229_b(BlockLeaves.field_176237_a)) {
            possible_spawns = getPossibleSpawnHeights(new BlockPos.MutableBlockPos(topPos), 16);
        }
        if (possible_spawns.isEmpty())
            return false;
        this.func_70107_b(field_70165_t, possible_spawns.get(field_70146_Z.nextInt(possible_spawns.size())), field_70161_v);
        return super.func_70601_bi();
    }

    private ArrayList<Integer> getPossibleSpawnHeights(BlockPos.MutableBlockPos pos, int limit) {
        ArrayList<Integer> heights = new ArrayList<>();
        int leaves = 0;
        for (int i = 0; i < limit; i++) {
            IBlockState state = field_70170_p.func_180495_p(pos);
            if (isJungleLeaves(state))
                leaves += 1;
            else
                leaves = 0;
            if (leaves == 2) //Only on top of leaves that are two blocks thick.
                heights.add(pos.func_177956_o() + 2);
            pos.func_189536_c(EnumFacing.DOWN);
        }
        return heights;
    }

    private boolean isJungleLeaves(IBlockState state) {
        return state.func_177230_c() == Blocks.field_150362_t && state.func_177229_b(BlockLeaves.field_176237_a);
    }
}
