package betterwithmods.common.entity;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BlockNetherGrowth;
import betterwithmods.common.blocks.blood_wood.BlockBloodSapling;
import betterwithmods.util.WorldUtils;
import com.google.common.collect.Lists;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.projectile.EntitySnowball;
import net.minecraft.init.SoundEvents;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.List;
import java.util.Random;

/**
 * Created by primetoxinz on 6/13/17.
 */
public class EntityUrn extends EntitySnowball {

    private static final List<ImpactHandler> handlers = Lists.newArrayList();
    static {
        addHandler(EntityUrn::grow);
    }

    public EntityUrn(World worldIn) {
        super(worldIn);
    }

    public EntityUrn(World worldIn, EntityLivingBase throwerIn) {
        super(worldIn, throwerIn);
    }

    public EntityUrn(World worldIn, double x, double y, double z) {
        super(worldIn, x, y, z);
    }

    @SideOnly(Side.CLIENT)
    public void func_70103_a(byte id) {
        if (id == 3) {
            for (int i = 0; i < 8; ++i) {
                this.field_70170_p.func_175688_a(EnumParticleTypes.BLOCK_DUST, this.field_70165_t, this.field_70163_u, this.field_70161_v, 0.1D, 0.5D, 0.1D, Block.func_176210_f(BWMBlocks.SOUL_URN.func_176223_P()));
            }
        }
    }

    /**
     * Called when this EntityThrowable hits a block or entity.
     */
    protected void func_70184_a(RayTraceResult result) {
        if (!this.field_70170_p.field_72995_K) {
            if (result.field_72313_a != RayTraceResult.Type.MISS) {

                field_70170_p.func_184133_a(null, func_180425_c(), SoundEvents.field_187825_fO, SoundCategory.PLAYERS, 0.5F, 0.4F / (field_70146_Z.nextFloat() * 0.4F + 0.8F));
                BlockPos pos = result.field_72313_a == RayTraceResult.Type.ENTITY ? result.field_72308_g.func_180425_c() : result.func_178782_a();

                Iterable<BlockPos> pool = BlockPos.PooledMutableBlockPos.func_177980_a(pos.func_177982_a(-3, -3, -3), pos.func_177982_a(3, 3, 3));

                boolean success = false;


                for(ImpactHandler handler: handlers) {
                    for (BlockPos p : pool) {
                        success |= handler.onImpact(field_70170_p, p, field_70146_Z);
                    }
                }
                if (!success) {
                    WorldUtils.spawnGhast(field_70170_p, pos);
                }
            }
            this.field_70170_p.func_72960_a(this, (byte) 3);
            this.func_70106_y();
        }
    }

    private static boolean grow(World world, BlockPos p, Random rand) {
        boolean grew = false;

        IBlockState state = world.func_180495_p(p);
        if (state.func_177230_c() == BWMBlocks.NETHER_GROWTH) {
            BlockNetherGrowth b = (BlockNetherGrowth) state.func_177230_c();
            for (int i = 0; i < 10; i++)
                b.grow(world, p, state, rand);
            grew = true;
        }

        if (state.func_177230_c() == BWMBlocks.BLOOD_SAPLING) {
            BlockBloodSapling sapling = (BlockBloodSapling) state.func_177230_c();
            if (sapling.generateTree(world, p, world.func_180495_p(p), rand))
                grew = true;
        }
        return grew;
    }

    public static void addHandler(ImpactHandler handler) {
        handlers.add(handler);
    }

    @FunctionalInterface
    public interface  ImpactHandler  {
        boolean onImpact(World world, BlockPos pos, Random random);
    }

}
