package betterwithmods.common.entity.ai;

import betterwithmods.util.PlayerUtils;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.ai.RandomPositionGenerator;
import net.minecraft.entity.monster.EntityPolarBear;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.Vec3d;

/**
 * The Entity will flee from threats in the opposite direction.
 *
 * @author Koward
 */
public class EntityAIFlee extends EntityAIBase {
    protected final double speed;
    private final EntityCreature creature;
    private double randPosX;
    private double randPosY;
    private double randPosZ;

    public EntityAIFlee(EntityCreature creature, double speedIn) {
        this.creature = creature;
        this.speed = speedIn;
        this.func_75248_a(1);
    }


    private boolean isValidEntity() {
        if (creature instanceof EntityPolarBear) {
            return creature.func_70631_g_();
        }
        return true;
    }

    /**
     * Returns whether the EntityAIBase should begin execution.
     */
    @Override
    public boolean func_75250_a() {
        Vec3d vec3d = null;
        Entity target = creature.func_70643_av();
        if (isValidEntity()) {
            if (this.creature.func_70027_ad()) {
                vec3d = RandomPositionGenerator.func_75463_a(this.creature, 5, 4);
            } else if (target != null && (!(target instanceof EntityPlayer) || PlayerUtils.isSurvival((EntityPlayer) target))) {
                vec3d = RandomPositionGenerator.func_75461_b(this.creature, 5, 0, new Vec3d(target.field_70165_t, target.field_70163_u, target.field_70161_v));
            }
        }

        if (vec3d != null) {
            this.randPosX = vec3d.field_72450_a;
            this.randPosY = vec3d.field_72448_b;
            this.randPosZ = vec3d.field_72449_c;
            return true;
        } else {
            return false;
        }
    }

    /**
     * Execute a one shot task or start executing a continuous task
     */
    @Override
    public void func_75249_e() {
        this.creature.func_70661_as().func_75492_a(this.randPosX, this.randPosY, this.randPosZ, this.speed);
    }

    /**
     * Returns whether an in-progress EntityAIBase should continue executing
     */
    @Override
    public boolean func_75253_b() {
        if (!this.creature.func_70661_as().func_75500_f() && this.creature.func_70643_av() != null) {
            EntityLivingBase target = this.creature.func_70643_av();

            if (target == null)
                return true;

            double sqDistToPos = this.creature.func_70092_e(this.randPosX, this.randPosY, this.randPosZ);

            if (sqDistToPos > 2.0D) {
                double sqDistToTarget = this.creature.func_70068_e(target);
                double sqDistOfTargetToPos = target.func_70092_e(this.randPosX, this.randPosY, this.randPosZ);

                return sqDistToTarget < sqDistOfTargetToPos;
            }
        }

        return false;
    }
}
