package betterwithmods.common.items.tools;

import betterwithmods.common.BWMOreDictionary;
import betterwithmods.module.general.InfernalEnchanting;
import betterwithmods.module.internal.ItemRegistry;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.EnumEnchantmentType;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemAxe;
import net.minecraft.item.ItemStack;
import net.minecraftforge.oredict.OreDictionary;

import javax.annotation.Nonnull;

public class ItemSoulforgedBattleAxe extends ItemAxe {
    public ItemSoulforgedBattleAxe() {
        super(ItemRegistry.SOULFORGED_STEEL, 9F, -2.4f);
    }

    @Override
    public boolean func_82789_a(ItemStack toRepair, @Nonnull ItemStack repair) {
        return BWMOreDictionary.listContains(repair, OreDictionary.getOres("ingotSoulforgedSteel")) || super.func_82789_a(toRepair, repair);
    }

    @Override
    public boolean canApplyAtEnchantingTable(ItemStack stack, Enchantment enchantment) {
        if (InfernalEnchanting.canEnchantSteel(enchantment)) {
            EnumEnchantmentType type = enchantment.field_77351_y;
            return type == EnumEnchantmentType.WEAPON || type == EnumEnchantmentType.DIGGER || type == EnumEnchantmentType.BREAKABLE || type == EnumEnchantmentType.ALL;
        }
        return false;

    }

    @Override
    public float func_150893_a(ItemStack stack, IBlockState state) {
        Block block = state.func_177230_c();
        Material material = state.func_185904_a();

        if (block == Blocks.field_150321_G) {
            return 15.0F;
        } else if (material == Material.field_151585_k || material == Material.field_151582_l || material == Material.field_151589_v || material == Material.field_151584_j || material == Material.field_151572_C) {
            return 1.5F;
        }

        return super.func_150893_a(stack, state);
    }


}
