package betterwithmods.common.registry.crafting;

import betterwithmods.lib.ModLib;
import betterwithmods.library.common.variants.IBlockVariants;
import betterwithmods.library.utils.ingredient.StackIngredient;
import betterwithmods.module.hardcore.crafting.HCLumber;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.SoundEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent;
import org.apache.commons.lang3.tuple.Pair;

import java.util.Set;

/**
 * Created by blueyu2 on 12/12/16.
 */
public class ChoppingRecipe extends ToolDamageRecipe {
    private final IBlockVariants wood;

    public ChoppingRecipe(IBlockVariants wood) {
        super(new ResourceLocation(ModLib.MODID, "chopping"), wood.getStack(IBlockVariants.EnumBlock.BLOCK, HCLumber.axePlankAmount), StackIngredient.fromStacks(wood.getStack(IBlockVariants.EnumBlock.LOG, 1)), ChoppingRecipe::isAxe);
        this.wood = wood;
        MinecraftForge.EVENT_BUS.register(this);
    }

    private static boolean isAxe(ItemStack stack) {
        if (stack != null) {
            Item item = stack.func_77973_b();
            Set<String> classes = item.getToolClasses(stack);
            if (classes.contains("axe") || classes.contains("mattock")) {
                ResourceLocation loc = item.getRegistryName();
                return loc == null || !loc.func_110624_b().equals("tconstruct") || stack.func_77952_i() < stack.func_77958_k();
            }
        }
        return false;
    }

    @Override
    public SoundEvent getSound() {
        return SoundEvents.field_187927_ha;
    }

    @Override
    public Pair<Float, Float> getSoundValues() {
        return Pair.of(0.25F, 2.5F);
    }

    @Override
    public ItemStack getExampleStack() {
        return new ItemStack(Items.field_151036_c);
    }

    public boolean shouldDamage(ItemStack stack, EntityPlayer player, IBlockState state) {
        if (isAxe(stack)) {
            Item item = stack.func_77973_b();
            int level = Math.max(item.getHarvestLevel(stack, "axe", player, state), item.getHarvestLevel(stack, "mattock", player, state));
            return level < 2;
        }
        return super.shouldDamage(stack, player, state);
    }

    @SubscribeEvent
    public void dropExtra(PlayerEvent.ItemCraftedEvent event) {
        if (event.player == null)
            return;
        if (isMatch(event.craftMatrix, event.player.field_70170_p)) {
            if (!event.player.func_130014_f_().field_72995_K) {
                event.player.func_70099_a(wood.getStack(IBlockVariants.EnumBlock.SAWDUST, HCLumber.axeSawDustAmount), 0);
                event.player.func_70099_a(wood.getStack(IBlockVariants.EnumBlock.BARK, HCLumber.axeBarkAmount), 0);
            }
        }
    }
}

