package betterwithmods.common.registry.hopper.filters;

import betterwithmods.common.tile.TileFilteredHopper;
import betterwithmods.lib.ModLib;
import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityXPOrb;
import net.minecraft.item.crafting.Ingredient;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import java.util.List;

public class SoulsandFilter extends HopperFilter {

    public SoulsandFilter(Ingredient filter, List<Ingredient> filtered) {
        super(new ResourceLocation(ModLib.MODID, "soul_sand"), filter, filtered);
    }

    @Override
    public void onInsert(World world, BlockPos pos, TileFilteredHopper tile, Entity entity) {
        if (entity instanceof EntityXPOrb && !tile.isXPFull()) {
            EntityXPOrb orb = (EntityXPOrb) entity;
            int remaining = tile.getMaxExperienceCount() - tile.getExperienceCount();
            int value = orb.func_70526_d();
            if (remaining > 0) {
                if (value <= remaining) {
                    tile.setExperienceCount(tile.getExperienceCount() + value);
                    orb.func_70106_y();
                    return;
                }
                orb.field_70530_e -= remaining;
                tile.setExperienceCount(tile.getMaxExperienceCount());
            }
        }
    }
}
