package betterwithmods.common.tile;

import betterwithmods.common.BWMItems;
import betterwithmods.common.blocks.BlockInfernalEnchanter;
import betterwithmods.library.common.inventory.FilteredStackHandler;
import betterwithmods.library.common.inventory.SimpleStackHandler;
import betterwithmods.library.common.tile.TileBasicInventory;
import betterwithmods.module.internal.AdvancementRegistry;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.Ingredient;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.ITickable;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.common.ForgeHooks;

import javax.annotation.Nonnull;
import java.util.List;

/**
 * Created by primetoxinz on 9/11/16.
 */
public class TileInfernalEnchanter extends TileBasicInventory implements ITickable {
    public final static int RADIUS = 8;
    private int bookcaseCount;
    private boolean active;

    private static float getPower(World world, BlockPos pos) {
        float power = ForgeHooks.getEnchantPower(world, pos);
        if (power > 0) {
            for (EnumFacing facing : EnumFacing.field_176754_o) {
                if (!world.func_180495_p(pos.func_177972_a(facing)).func_185904_a().func_76220_a())
                    return power;
            }
        }
        return 0;
    }

    @Override
    public void func_73660_a() {
        if (func_145831_w().func_82737_E() % 20 == 0) {
            bookcaseCount = 0;
            for (int x = -RADIUS; x <= RADIUS; x++) {
                for (int y = -RADIUS; y <= RADIUS; y++) {
                    for (int z = -RADIUS; z <= RADIUS; z++) {
                        BlockPos current = field_174879_c.func_177982_a(x, y, z);
                        float power = getPower(field_145850_b, current);
                        if (power > 0) {
                            bookcaseCount += power;
                        }
                    }
                }
            }
        }

        if (func_145831_w().func_82737_E() % 5 == 0) {
            List<EntityPlayer> playerList = field_145850_b.func_72872_a(EntityPlayer.class, new AxisAlignedBB(field_174879_c).func_186662_g(8));
            boolean players = !playerList.isEmpty();
            if (active != players) {
                active = players;
                if (active)
                    field_145850_b.func_184133_a(null, field_174879_c, SoundEvents.field_187616_bj, SoundCategory.BLOCKS, 0.75f, 1);
                else {
                    field_145850_b.func_184133_a(null, field_174879_c, SoundEvents.field_187646_bt, SoundCategory.BLOCKS, 0.1f, 1);
                }
            }
            IBlockState state = field_145850_b.func_180495_p(field_174879_c);
            if (active) {
                field_145850_b.func_175656_a(field_174879_c, state.func_177226_a(BlockInfernalEnchanter.ACTIVE, true));
                int x = field_174879_c.func_177958_n(), y = field_174879_c.func_177956_o(), z = field_174879_c.func_177952_p();
                func_145831_w().func_175688_a(EnumParticleTypes.FLAME, x + .125, y + .9, z + .125, 0, 0, 0);
                func_145831_w().func_175688_a(EnumParticleTypes.FLAME, x + .875, y + .9, z + .125, 0, 0, 0);
                func_145831_w().func_175688_a(EnumParticleTypes.FLAME, x + .875, y + .9, z + .875, 0, 0, 0);
                func_145831_w().func_175688_a(EnumParticleTypes.FLAME, x + .125, y + .9, z + .875, 0, 0, 0);

                playerList.stream().filter(p -> p instanceof EntityPlayerMP).map(p -> (EntityPlayerMP) p).forEach(player -> AdvancementRegistry.CONSTRUCT_LIBRARY.trigger(player, getBookcaseCount()));
            } else {
                field_145850_b.func_175656_a(field_174879_c, state.func_177226_a(BlockInfernalEnchanter.ACTIVE, false));

            }
        }
    }

    public int getBookcaseCount() {
        return bookcaseCount;
    }

    @Override
    public int getInventorySize() {
        return 2;
    }

    @Nonnull
    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        compound.func_74768_a("bookcaseCount", bookcaseCount);
        compound.func_74757_a("active", active);
        return super.func_189515_b(compound);

    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        bookcaseCount = compound.func_74762_e("bookcaseCount");
        active = compound.func_74767_n("active");
        super.func_145839_a(compound);
    }

    public boolean isActive() {
        return active;
    }

    @Override
    public SimpleStackHandler createItemStackHandler() {
        return new InfernalEnchanterHandler(this);
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, @Nonnull IBlockState oldState, @Nonnull IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }

    public ItemStack getActiveItem() {
        return this.inventory.getStackInSlot(1);
    }

    private class InfernalEnchanterHandler extends FilteredStackHandler {
        InfernalEnchanterHandler(TileEntity tile) {
            super(2, tile, Ingredient.func_193367_a(BWMItems.ARCANE_SCROLL));
        }
    }
}
