package betterwithmods.module.conversion.beacons;

import betterwithmods.library.utils.CapabilityUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.InventoryEnderChest;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.tileentity.TileEntityEnderChest;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import net.minecraftforge.common.DimensionManager;

import javax.annotation.Nonnull;
import java.util.function.BiFunction;

import static betterwithmods.module.conversion.beacons.EnderchestCap.ENDERCHEST_CAPABILITY;

public class TileEnderchest extends TileEntityEnderChest {

    private Type type = Type.NONE;

    @Nonnull
    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        compound.func_74768_a("type", type.ordinal());
        return super.func_189515_b(compound);
    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        if (compound.func_74764_b("type"))
            this.type = Type.VALUES[compound.func_74762_e("type")];
        super.func_145839_a(compound);
    }

    @Nonnull
    public Type getType() {
        return type;
    }

    public void setType(Type type) {
        this.type = type;
    }

    public enum Type {
        NONE((tile, player) -> CapabilityUtils.getCapability(tile.func_145831_w(), ENDERCHEST_CAPABILITY, EnumFacing.UP).map(EnderchestCap::getInventory).orElse(null)),
        DIMENSION1((tile, player) -> {
            World world = tile.func_145831_w();
            return CapabilityUtils.getCapability(world, ENDERCHEST_CAPABILITY, EnumFacing.SOUTH).map(EnderchestCap::getInventory).orElse(null);
        }),
        DIMENSION2((tile, player) -> CapabilityUtils.getCapability(tile.func_145831_w(), ENDERCHEST_CAPABILITY, EnumFacing.NORTH).map(EnderchestCap::getInventory).orElse(null)),
        GLOBAL((tile, player) -> CapabilityUtils.getCapability(DimensionManager.getWorld(0), ENDERCHEST_CAPABILITY, EnumFacing.DOWN).map(EnderchestCap::getInventory).orElse(null)),
        PRIVATE((tile, player) -> player.func_71005_bN());

        public static final Type[] VALUES = values();

        private final BiFunction<TileEntity, EntityPlayer, InventoryEnderChest> function;

        Type(BiFunction<TileEntity, EntityPlayer, InventoryEnderChest> function) {
            this.function = function;
        }

        public BiFunction<TileEntity, EntityPlayer, InventoryEnderChest> getFunction() {
            return function;
        }
    }


}

