package betterwithmods.module.general.moreheads.common;

import betterwithmods.library.common.tile.TileBasic;
import betterwithmods.library.utils.DirUtils;
import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;

public class TileHead extends TileBasic {

    private HeadType type;
    private int rotation;

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        if (type != null) {
            compound.func_74778_a("type", type.func_176610_l());
        }
        compound.func_74768_a("rotation", rotation);
        return super.func_189515_b(compound);
    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        type = HeadType.getValue(value(compound, "type", ""));
        rotation = value(compound, "rotation", 0);
        super.func_145839_a(compound);
    }

    public void setType(HeadType type) {
        this.type = type;
    }

    public void setRotation(int rotation) {
        this.rotation = rotation;
    }

    public HeadType getType() {
        return type;
    }

    public float getRotation() {
        IBlockState state = field_145850_b.func_180495_p(func_174877_v());
        EnumFacing facing = state.func_177229_b(DirUtils.FACING);
        switch (facing) {
            case UP:
                return (int) ((float) (rotation * 360) / 16.0F);
            case NORTH:
                return 0;
            case SOUTH:
                return 180;
            case WEST:
                return 270;
            case EAST:
                return 90;
        }
        return 0;
    }
}

