package betterwithmods.module.tweaks;

import betterwithmods.BetterWithMods;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.common.registry.bulk.recipes.builder.CrucibleRecipeBuilder;
import betterwithmods.lib.ModLib;
import betterwithmods.library.common.modularity.impl.Feature;
import betterwithmods.library.common.recipes.RecipeMatchers;
import betterwithmods.library.common.recipes.RecipeRemover;
import betterwithmods.module.internal.RecipeRegistry;
import betterwithmods.module.recipes.MetalReclaming;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;


public class DetectorRail extends Feature {

    @Override
    public String getDescription() {
        return "Change what detector rails detect; Wooden:all minecarts; Stone: carts containing something, SFS: carts with players.";
    }

    @Override
    public void onPreInitClient(FMLPreInitializationEvent event) {
        config().overrideBlockResource("rail_detector");
        config().overrideBlockResource("rail_detector_powered");
    }

    @Override
    public void onPreInit(FMLPreInitializationEvent event) {
        Blocks.field_150319_E.func_149663_c(ModLib.MODID + ":detector_rail_wood");
    }

    @Override
    public void registerRecipes() {
        RecipeRegistry.removeRecipe(new RecipeRemover<>(RecipeMatchers.REGISTRY_NAME, Blocks.field_150319_E.getRegistryName()));
    }

    @Override
    public void onInit(FMLInitializationEvent event) {
        if (BetterWithMods.MODULE_LOADER.isFeatureEnabled(MetalReclaming.class)) {
            CrucibleRecipeBuilder builder = new CrucibleRecipeBuilder();
            RecipeRegistry.CRUCIBLE.registerAll(
                    builder.stoked().inputs(new ItemStack(BWMBlocks.DETECTOR_RAIL_STONE, 6)).outputs(new ItemStack(Items.field_151042_j, 6)).build(),
                    builder.stoked().inputs(new ItemStack(BWMBlocks.DETECTOR_RAIL_STEEL, 6)).outputs(new ItemStack(Items.field_151042_j, 6), ItemMaterial.getStack(ItemMaterial.EnumMaterial.STEEL_INGOT, 2)).build()

            );
        }
    }
}
